/************************************************************************************************

 Author        : ADI - Apps            www.analog.com

 Date          : July 2009

 File          : ADC.c

 Hardware      : ADuC7122

 Description   : This Simple ADC example shows how to initialize the Primary ADC for 
 			continuous sampling using channel AIN6 in Single-ended mode.
*************************************************************************************************/

// Bit Definitions
#define BIT0  0x01
#define BIT1  0x02
#define BIT2  0x04
#define BIT3  0x08
#define BIT4  0x10
#define BIT5  0x20
#define BIT6  0x40
#define BIT7  0x80
#define BIT8  0x100
#define BIT9  0x200
#define BIT10 0x400
#define BIT11 0x800
#define BIT12 0x1000
#define BIT13 0x2000
#define BIT14 0x4000
#define BIT15 0x8000

#include <ADuC7122.h>

void delay (int);

unsigned int szADCvalues[16];			// Variable that ADCDAT is read into in ADC IRQ
int i=0;
int time=2000;


int main(void)
{
    POWKEY1 = 0x01;		          		// Configure CPU Clock for 41.78MHz, CD=0
 	POWCON = 0x00;
 	POWKEY2 = 0xF4;       

        
    // Configure ADC
     
    ADCCON = 0x20;	 		    		// power-on the ADC
	while (time >=0)	  	    		// wait for ADC to be fully powered on
    time--;    
    ADCCON =BIT2+BIT5+BIT7+BIT9+BIT11;  // software conv., single-ended, conv. enabled
    ADCCP = BIT3;                       // Select AIN6 channel    
    REFCON=BIT1;                        // Internal 2.5V reference
    IRQEN=BIT12;                        // Enable ADC interrupt

    while (1)
    {     
    }
}


void IRQ_Handler(void) //__irq
{
        
	unsigned long IRQSTATUS = 0;
 
	IRQSTATUS = IRQSTA;	                    // Read off IRQSTA register
        
    if ((IRQSTATUS & BIT12) == BIT12)	    //If ADC interrupt source
	{
       if(i<16)
       {
			szADCvalues[i] = ADCDAT>>16;	// Read ADC conversion result
        	i++;
       }
       if(i==16)
       {
            i=0;							// End of read
            IRQCLR = BIT12;
       }
  	}
}

void delay (int length)
{
	while (length >0)
    length--;
}
